print "__SAGE_BEGIN__385"
os.chdir("/Volumes/HOME/talks/2006-08-28-musa/sage_notebook/worksheets/bsd/cells/23")
print """
<html><font color=black>
ASIDE -- big recent theorem of Taylor, Harris,
Clozel, Shepherd-Barron
<br>
THE SATO-TATE CONJECTURE is a theorem<br>
(in a wide range of cases).
</font></html>"""

#%auto
def dist(v, b, left=float(Integer(0)), right=float(pi)):
    """
    We divide the interval between left (default: 0) and
    right (default: pi) up into b bins.

    For each number in v (which must left and right),
    we find which bin it lies in and add this to a counter.
    This function then returns the bins and the number of
    elements of v that lie in each one.

    ALGORITHM: To find the index of the bin that a given
    number x lies in, we multiply x by b/length and take the
    floor.
    """
    length = right - left
    normalize = float(b/length)
    vals = {}
    d = dict([(i,Integer(0)) for i in range(b)])
    for x in v:
        n = int(normalize*(float(x)-left))
        d[n] += Integer(1)
    return d, len(v)


def graph(d, b, num=Integer(5000), left=float(Integer(0)), right=float(pi)):
    s = Graphics()
    left = float(left); right = float(right)
    length = right - left
    w = length/b
    k = Integer(0)
    for i, n in d.iteritems():
        k += n
        # ith bin has n objects in it.
        s += polygon([(w*i+left,Integer(0)), (w*(i+Integer(1))+left,Integer(0)),                      (w*(i+Integer(1))+left, n/(num*w)),                       (w*i+left, n/(num*w))],\
                     rgbcolor=(Integer(0),Integer(0),RealNumber('0.5')))
    return s

def sato_tate(E, N):
    return [E.ap(p)/(2*sqrt(p)) for p in prime_range(N+1)                 if N%p != 0]

def graph_ellcurve(E, b=Integer(10), num=Integer(5000)):
    v = sato_tate(E, num)
    d, total_number_of_points = dist(v,b,-Integer(1),Integer(1))
    return graph(d, b, total_number_of_points,-Integer(1),Integer(1))

C = plot( lambda x: (Integer(2)/pi) * sqrt(Integer(1)-x**Integer(2)), -Integer(1), Integer(1),               plot_points=Integer(200),               rgbcolor=(Integer(1),Integer(0),Integer(0)), thickness=Integer(4),alpha=RealNumber('0.7'))
G = graph_ellcurve(E,Integer(50),num=Integer(50000))
exec compile(ur'show(C + G, ymin=Integer(0), ymax=RealNumber(\u0027.75\u0027), figsize=[Integer(8),Integer(4)])' + '\n', '', 'single')
print "__SAGE_VARS__=%s"%_support_.variables(True)
print "__SAGE_END__385"
